#include <stdlib.h>
#include <setjmp.h>

#include "rally.h"

jmp_buf env;

extern char* get_name();
extern void get_ready();
extern char* get_moves();

extern char *rally_host;
extern int rally_port;

int main(int argc, char **argv) {
	int ret;

	if (argc >= 2) {
		rally_host = argv[1];
		if (argc >= 3)
			rally_port = atoi(argv[2]);
	}
	
	if ((ret = rally_connect()) < 0)
		bail("Failed to connect: %s", strerror(ret));

	set_name(get_name());

	setjmp(env);
	for(;;) {
		rally_wait_for_game();
		log("I: Game started.");
		get_ready();
		while (winner == -1) {
			wait_until_ready_to_move();
			if (winner == -1) {
				submit_moves(get_moves());
				wait_for_results(NULL);
			}
		}
		log("I: Game ended.");
	}

	rally_disconnect();

	return 0;
}
