#ifndef _PLAYER_H_
#define _PLAYER_H_

#ifdef __cplusplus
extern "C" {
#endif

#define MOVES_PER_ROUND		5
#define MAX_BOARD_SIZE		10

#define MAX_CLIENTS 25
#define MAX_PLAYERS 20

#define STARTING_HEALTH		5

typedef enum {
	MOVE_NORTH		= '^',
	MOVE_SOUTH		= 'v',
	MOVE_WEST		= '<',
	MOVE_EAST		= '>',
	MOVE_TURN_LEFT		= '(',
	MOVE_TURN_RIGHT		= ')',
	MOVE_SHOOT		= 'S',
	MOVE_PUNCH		= 'P',
	MOVE_REPAIR		= 'R',
	MOVE_NOTHING		= '-',
} move;

typedef enum {
	NORTH = 0,
	EAST,
	SOUTH,
	WEST,
} direction;

typedef struct {
	int r, c, dir, health;
	char name[15];
} player;

extern int player_number;
extern int number_of_players;
extern int board_size;
extern int board[MAX_BOARD_SIZE][MAX_BOARD_SIZE];
extern player *players;

#ifdef __cplusplus
}
#endif

#endif /* _PLAYER_H_ */
