#include <stdio.h>
#include "rally.h"

#define COLOURBOARD

char *board_colour = "0;44";

char *colours[] = {
	"1;30;41", /* red */
	"1;30;42", /* green */
	"1;30;43", /* yellow */
	"1;30;45", /* magenta */
	"1;30;46", /* cyan */
	"1;30;47", /* white */
	"1;37;41", /* red */
	"1;37;42", /* green */
	"1;37;43", /* yellow */
	"1;37;45", /* magenta */
	"1;37;46", /* cyan */
	"1;37;41", /* red */
	"1;37;42", /* green */
	"1;37;43", /* yellow */
	"1;37;45", /* magenta */
	"1;37;46", /* cyan */
	"1;34;41", /* red */
	"1;34;42", /* green */
	"1;34;43", /* yellow */
	"1;34;45", /* magenta */
	"1;34;46", /* cyan */
	"1;34;41", /* red */
	"1;34;42", /* green */
	"1;34;43", /* yellow */
	"1;34;45", /* magenta */
	"1;34;46", /* cyan */
};

void print_board(int move_num) {
	int r, c, np;
	/* printf("\033[2J"); */
	printf("\033[0;0H");
	np = 0;
	for (r = 0; r < board_size; r++) {
		for (c = 0; c < board_size; c++) {
			printf("%c", (board[r][c]!=-1)?(board[r][c]+'0'):'.');
		}
		for ( ; np < MAX_CLIENTS; np++) {
			if (players[np].name[0]) {
				printf("   %d: %s", np, players[np].name);
				np++;
				break;
			}
		}
		printf("\n");
	}
	printf("\n");
}

static void print_horiz_div() {
	int i;
	for (i = 0; i < board_size; i++)
#ifdef COLOURBOARD
		printf("\033[%sm    \033[0m", board_colour);
	printf("\033[%sm \033[0m\n", board_colour);
#else
		printf("+---");
	printf("+\n");
#endif
}

static void print_empty_board() {
	int x, y;
	for (y = 0; y < board_size; y++) {
		print_horiz_div();
		for (x = 0; x < board_size; x++) 
#ifdef COLOURBOARD
			printf("\033[%sm \033[0m   ", board_colour);
		printf("\033[%sm \033[0m\n", board_colour);
#else
			printf("|   ", board_colour);
		printf("|\n", board_colour);
#endif
	}
	print_horiz_div();
}

static void move_to_pos(int r, int c) {
	printf("\033[%d;%dH", r*2+2, c*4+2);
}

void print_player(int pn) {
	char c = '?';
	switch (players[pn].dir) {
		case NORTH:
			c = '^';
			break;
		case SOUTH:
			c = 'v';
			break;
		case EAST:
			c = '>';
			break;
		case WEST:
			c = '<';
			break;
	}
	printf("\033[%sm %c \033[0m", colours[pn], c);
}

void pretty_print_board(int move_num) {
	int r, c, np;
	extern int expected_move_serial;
	/* printf("\033[2J"); */
	printf("\033[0;0H");
	printf("\033[?25l\033[?1c");
	print_empty_board();
	for (r = 1, np = 0; np < MAX_CLIENTS; np++) {
		if (players[np].name[0]) {
			printf("\033[%d;%dH   ", r, board_size*4+4);
			print_player(np);
			printf(" %-20s", players[np].name);
			for(c = 0; c < STARTING_HEALTH-players[np].health; c++)
				printf("X");
			printf("\033[0K");
			r++;
		}
	}
	printf("\033[%d;%dHMove %d of round %d", r+1, board_size*4+4, move_num, expected_move_serial);
	for (r = 0; r < board_size; r++) {
		for (c = 0; c < board_size; c++) {
			if (board[r][c] != -1) {
				move_to_pos(r, c);
				print_player(board[r][c]);
			}
		}
		printf("\n");
	}
	printf("\n");
	move_to_pos(r, 0);
	fflush(stdout);
}
