#include <stdlib.h>
#include <setjmp.h>

#include "rally.h"

jmp_buf env;
extern char *rally_host;
extern int rally_port;


extern void pretty_print_board(int move_num);

int main(int argc, char **argv) {
	int ret;
	
	if (argc >= 2) {
		rally_host = argv[1];
		if (argc >= 3)
			rally_port = atoi(argv[2]);
	}
	
	if ((ret = rally_connect()) < 0)
		bail("Failed to connect: %s", strerror(ret));

	am_watcher();

	/* setvbuf(stdout, NULL, _IONBF, 0); */
	setjmp(env);
	for(;;) {
		rally_wait_for_game();
		log("Game started.");
		printf("\033[2J");
		pretty_print_board(0);
		while (winner == -1) {
			wait_until_ready_to_move();
			wait_for_results(pretty_print_board);
		}
		pretty_print_board(0);
		log ("Game ended.\033[0K\n");
		if (winner >= 0)
			log("Game ended. Winner is %s\033[0K\n", players[winner].name);
		/* return 0; */
	}

	rally_disconnect();

	return 0;
}
